{    var   : }
{ N, FT }
Unit MNK3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNKU5_p, MNKU6_p, MNKO3_p, MNKO2_p, MNKU1_p;

procedure MNK3R(var N :Integer; var I1 :Array of Integer;
                var P :Array of Real; HB :Real; var HT :Real;
                var XT :Array of Real; var FT :Real; var FTE :Real;
                var G1 :Array of Real; var G1E :Array of Real;
                FUNC :Proc_F1_MN; GRAD :Proc_F2_MN; var UP :Array of Real;
                var WP :Array of Integer; var RM :Array of Real);

implementation

procedure MNK3R(var N :Integer; var I1 :Array of Integer;
                var P :Array of Real; HB :Real; var HT :Real;
                var XT :Array of Real; var FT :Real; var FTE :Real;
                var G1 :Array of Real; var G1E :Array of Real;
                FUNC :Proc_F1_MN; GRAD :Proc_F2_MN; var UP :Array of Real;
                var WP :Array of Integer; var RM :Array of Real);
var
WCK,NY,NF,NG,W4,W5,CM,KOMAX,EM,EM1,KP1,KP2,Y,Z :Integer;
GMAX,PG,EPS2,FF,H,CAB1,EPS1,EPS,C1,CK,E,E1,A,C,X,X1,G,J,B,D,K,K1,F,W,
   W1,I :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
{   OPOPAMMA OHOMEPHO MHMA }
{   YHK F(XT-H*P) HA OTPEKE (,HB) }
{   C COOBAHEM HEHO  KBAPATHO APOKCMA }
{   POBOHO O HAPABEH }
{   HACTPOKA }
CM := Trunc(UP[0]);
CK := UP[1];
WCK := Trunc(UP[2]);
KOMAX := Trunc(UP[3]);
EM := Trunc(UP[4]);
EM1 := Trunc(UP[5]);
H := HT;
FF := FT;
CAB1 := FTE;
for Y:=1 to N do
 begin
  RM[Y-1] := XT[Y-1];
  NY := N+Y;
_1:
  RM[NY-1] := G1E[Y-1];
 end;
Z := N+1;
{   HAAHE OPMPOBAH }
GMAX := 0.0;
EPS2 := 0.0;
for Y:=1 to N do
 begin
  if ( I1[Y-1] = 0 ) 
   then goto _2;
  if ( Abs(G1[Y-1]) > GMAX ) 
   then GMAX := Abs(G1[Y-1]);
  if ( Abs(G1E[Y-1]) > EPS2 ) 
   then EPS2 := Abs(G1E[Y-1]);
_2:
 end;
MNKU5(N,I1,P,G1,GMAX,PG);
EPS1 := Power(10.0,-1 -EM/2);
NF := 0;
NG := 0;
W4 := 0;
W5 := 0;
KP1 := 0;
KP2 := 0;
E := PG;
E1 := EPS2;
{   OCK BYX TOEK A  C  OCTPOEH }
{   HEHO APOKCMA }
A := 0.0;
C := H;
_3:
if ( C < HB ) 
 then goto _4;
C := HB;
W5 := 1;
_4:
MNKU6(N,NG,I1,P,RM[0],XT,C,G1,G1E,RM[Z-1],X,X1,
     GRAD);
W4 := 1;
if ( X > EPS1 ) 
 then goto _6;
_5:
HT := C;
goto _12;
_6:
MNKU5(N,I1,P,G1,X,G);
if ( Abs(G) < EMax1(X1,Power(10.0,2-EM)) ) 
 then goto _5;
if ( G < 0.0 ) 
 then goto _7;
if ( W5 = 1 ) 
 then goto _5;
A := C;
E := G;
E1 := X1;
C := CM*C;
if ( CM <> 1 ) 
 then goto _3;
C := A+H;
if ( NG < KOMAX ) 
 then goto _3;
HT := A;
goto _16;
{   HEHA APOKCMA, }
_7:
if ( W5 = 1 ) 
 then W5 := 0;
W4 := 0;
J := E/G;
HT := (J*C-A)/(J-1);
KP2 := KP2+1;
if ( PG < EPS1 ) 
 then goto _12;
B := HT;
D := HT;
{   BCEHE POBOHO O HAPABEH B TOKE HT=B, }
{   COOCTABEHE EE CO HAEHM POBOHX }
{   B TOKAX A  C  X OPEHOCTM }
MNKU6(N,NG,I1,P,RM[0],XT,HT,G1,G1E,RM[Z-1],K,K1,
     GRAD);
W4 := 1;
if ( K < EPS1 ) 
 then goto _12;
MNKU5(N,I1,P,G1,K,F);
EPS := EMax1(EMax1(EMax1(K1,X1),E1),EPS1);
if ( Abs(F) < EPS ) 
 then goto _12;
C1 := EMax1(Abs(E),Abs(G));
if ( C1 < 1.0 ) 
 then goto _8;
C1 := Log10(C1);
EPS := EMax1(EPS,Power(10.0,Trunc(C1+1)-EM1));
if ( Abs(F) < EPS ) 
 then goto _12;
_8:
{   KBAPATHA APOKCMA O TOKAM A,B,C }
_9:
W4 := 0;
MNKO3(A,B,C,E,F,G,HT,EM);
KP1 := KP1+1;
if ( WCK <> 1 ) 
 then goto _10;
if ( Abs(HT-D) < EMax1(D*CK,Power(10.0,2-EM)) ) 
 then goto _12;
goto _11;
_10:
if ( Abs(HT-D) < CK ) 
 then goto _12;
_11:
MNKU6(N,NG,I1,P,RM[0],XT,HT,G1,G1E,RM[Z-1],W,W1,
     GRAD);
W4 := 1;
if ( W < EPS1 ) 
 then goto _12;
MNKU5(N,I1,P,G1,W,I);
EPS := EMax1(W1,EPS);
if ( Abs(I) < EPS ) 
 then goto _12;
{   BOP HOBX TPEX TOEK  OCTPOEH OEPEHO }
{   KBAPATHO APOKCMA }
MNKO2(D,HT,A,B,C,E,F,G,I);
goto _9;
{   OPAOTKA PEYTATOB OHOMEPHO MHMA }
{    BCEHE YHK }
_12:
MNKU1(N,NF,I1,P,RM[0],XT,HT,FT,FTE,CAB1,FUNC);
if ( FT < FF ) 
 then goto _18;
if ( KP1 = 0 ) 
 then goto _13;
if ( F < 0.0 ) 
 then goto _14;
HT := B;
goto _15;
_13:
if ( W5 = 1 ) 
 then goto _17;
_14:
if ( A = 0.0 ) 
 then goto _17;
HT := A;
_15:
W4 := 0;
_16:
MNKU1(N,NF,I1,P,RM[0],XT,HT,FT,FTE,CAB1,FUNC);
if ( FT < FF ) 
 then goto _18;
_17:
W5 := 2;
{   BXO  OHOMEPHO MHMA }
_18:
WP[0] := NF;
WP[1] := NG;
WP[2] := W4;
WP[3] := W5;
end;

end.
