Unit MNKO2_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNKO2(var D :Real; HT :Real; var A :Real; var B :Real;
                var C :Real; var E :Real; var F :Real; var G :Real;
                I :Real);

implementation

procedure MNKO2(var D :Real; HT :Real; var A :Real; var B :Real;
                var C :Real; var E :Real; var F :Real; var G :Real;
                I :Real);
var
BA,BB :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
{   BOP TPEX TOEK  OCTPOEH APAO }
{    MEXC ETPEX TOEK A,B,C,HT }
if ( I > 0.0 ) 
 then goto _3;
if ( F < 0.0 ) 
 then goto _4;
_1:
if ( EMax1(B,HT)-A < C-EMin1(B,HT) ) 
 then goto _4;
_2:
A := HT;
E := I;
goto _5;
_3:
if ( F < 0.0 ) 
 then goto _1;
goto _2;
_4:
C := HT;
G := I;
_5:
D := HT;
if ( B > A ) 
 then goto _6;
BA := A;
A := B;
B := BA;
BA := E;
E := F;
F := BA;
_6:
if ( C > B ) 
 then goto _8;
if ( C > A ) 
 then goto _7;
BA := A;
BB := B;
A := C;
B := BA;
C := BB;
BA := E;
BB := F;
E := G;
F := BA;
G := BB;
goto _8;
_7:
BA := B;
B := C;
C := BA;
BA := F;
F := G;
G := BA;
_8:
end;

end.
