{    var   : }
{ M, N, LA, F, FE }
Unit MNR5R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTMN05_p, MNR1N_p, MNR56_p, MNR52_p, MNR55_p, MNR51_p, ML03R_p,
MNR54_p, ML07R_p, MNR53_p, MNR1S_p, MNK3R_p;

procedure MNR5R(var N :Integer; var M :Integer; var X :Array of Real;
                var XE :Array of Real; var I0 :Array of Integer;
                var A :Array of Real; var B :Array of Real;
                var B1 :Array of Real; var LA :Integer;
                var A1 :Array of Real; var NS :Array of Integer;
                var T :Array of Real; FUNC :Proc_F1_MN; var F :Real;
                var FE :Real; GRAD :Proc_F2_MN; var G :Array of Real;
                var GE :Array of Real; var UP :Array of Real;
                var RM :Array of Real; var IRM :Array of Integer;
                var IRM1 :Array of Integer; var IERR :Integer);

implementation

procedure MNR5R(var N :Integer; var M :Integer; var X :Array of Real;
                var XE :Array of Real; var I0 :Array of Integer;
                var A :Array of Real; var B :Array of Real;
                var B1 :Array of Real; var LA :Integer;
                var A1 :Array of Real; var NS :Array of Integer;
                var T :Array of Real; FUNC :Proc_F1_MN; var F :Real;
                var FE :Real; GRAD :Proc_F2_MN; var G :Array of Real;
                var GE :Array of Real; var UP :Array of Real;
                var RM :Array of Real; var IRM :Array of Integer;
                var IRM1 :Array of Integer; var IERR :Integer);
var
I,IAL,IALJ,IIP,IP,IPJ1,IR2,IRV,IRVJ1,IRX,IRXJ1,ISUM,ITM,IU,IUP,IXK,J,
   K,KRV,M1,MAXIT,NE,P,PR,MACC,INX,INT,INSUM,J1,KP :Integer;
DEL,EPS,FE1,FT,H,HL,MT,S,T0,T1,Z,Z1,ZB1,C,OPM,POBAH,E,PECOB,PA,O,BOB,
   POBEPKA,TEP,EB,OKOH,AH,ETA :Real;
label
_10,_20,_30,_40,_50,_60,_65,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170;
begin
UTMN05(T0);
IERR := 0;
P := 0;
MAXIT := Trunc( RM[0] );
MT := UP[0];
RM[0] := 0;
RM[1] := 0;
RM[2] := 0;
{   OPMPOBAHE APECOB PAOX MACCBOB }
{  HAAO PAOEO BEKTOPA RV }
INX := N+1;
IRV := 4;
{  HAAO BEKTOPA CYCKA P }
IP := 4 + N;
{  HAAO MACCBA UP  }
{  OHOMEPHO MHMA }
IUP := 4 + 2*N;
{  HAAO MACCBA RM  }
{  OHOMEPHO MHMA }
IR2 := 2*N + 10;
{  HAAO MACCBA U  }
{  CMEKC-METOA }
IU := 10 + 4*N;
{  HAAO MACCBA XK  }
{  CMEKC-METOA }
IXK := 10 + 4*N + M*M;
{  HAAO MACCBA SUM  }
{  CMEKC-METOA }
ISUM := IXK + M;
{  HAAO EOO MACCBA IP  }
{  OHOMEPHO MHMA }
IIP := N + 1;
{  HAAO MACCBA ALFA  }
{  CMEKC-METOA }
IAL := ISUM + N;
IRX := IAL + N;
INT := IIP + 4;
INSUM := INT +N;
{   OPM POBAH E MACCBA T }
for J:=1 to N do
 begin
  J1 := INT + J-1;
  IRM[J1-1] := Trunc( T[J-1]+0.5 );
  T[J-1] := 0.0;
_10:
 end;
for J:=1 to N do
 begin
  IRM[J-1] := I0[J-1];
_20:
 end;
for J:=1 to N do
 begin
  IALJ := IAL + J - 1;
  RM[IALJ-1] := B[J-1] - A[J-1];
  IRM1[J-1] := J;
_30:
 end;
for J:=1 to N do
 begin
  if ( X[J-1] <  A[J-1] ) 
   then X[J-1] := A[J-1];
  if ( X[J-1] >  B[J-1] ) 
   then X[J-1] := B[J-1];
_40:
 end;
M1 := M - 2;
B1[M-2] := 0;
B1[M-1] := 0;
MNR1N(B1,M1,ZB1);
{  OPMPOBAHE EPS  }
{  CMEKC-METOA }
EPS := UP[3]*ZB1;
{   POBEPKA OYCTMOCT HAAHOO BEKTOPA }
MNR56(A1,IRM[INT-1],NS,B1,M,X,N,RM[IRV-1],EPS,PR);
{  OPMPOBAHE BEKTOPA PABX ACTE: }
{  B1=B1-A1*A }
MNR52(A1,NS,IRM[INT-1],N,A,B1,M);
{   PBEEHE CCTEM K BY, }
{   KOA BEKTOP PABX ACTE HEOTPATEEH }
MNR55(B1,M,A1,LA,NS);
for I:=1 to M1 do
 begin
  B1[M-1] := B1[M-1] - B1[I-1];
_50:
 end;
{  OPMPOBAHE MACCBA SUM }
MNR51(A1,IRM[INT-1],N,RM[ISUM-1]);
if ( PR =  0 ) 
 then goto _70;
{   OCK OYCTMO TOK }
GRAD(X,G,GE,I0);
RM[2] := RM[2]+1;
for J:=1 to N do
 begin
  T[J-1] := G[J-1];
_60:
 end;
ML03R(A1,1,RM[IU-1],M,T,N,RM[ISUM-1],NS,IRM[INT-1],IRM[INSUM-1],
     B1,IRM1[INX-1],P,EPS,
     RM[IXK-1],RM[IAL-1],N,IRM1);
if ( P <> 2 ) 
 then goto _65;
IERR := 65;
goto _170;
_65:
MNR54(B1,M,X,IRM1[INX-1],N,A,RM[IAL-1],IRM1);
P := 2;
NE := 2;
_70:
ITM := 0;
DEL := 2.0/(N*(N + 1));
IRM[IIP+1] := 0;
{  OPMPOBAHE HAAHX TOHOCTE }
{  O X  O F }
MNR1N(XE,N,Z);
Z1 := Z*IntPower(UP[1],5);
FE1 := FE*IntPower(UP[2],5);
FUNC(X,F,FE);
RM[1] := RM[1] + 1;
_80:
{   OPMPOBAHE BCOMOATEHO AA }
{   HEHOO POPAMMPOBAH }
GRAD(X,G,GE,I0);
RM[2] := RM[2] + 1;
_90:
for J:=1 to N do
 begin
  T[J-1] := G[J-1];
_100:
 end;
ML07R(A1,LA,RM[IU-1],M,T,N,RM[ISUM-1],NS,IRM[INT-1],IRM[INSUM-1],
     NE,B1,IRM1[INX-1],P,EPS,
     RM[IXK-1],RM[IAL-1],N,IRM1);
{  BCEHE HAPABEH CYCKA }
MNR54(B1,M,RM[IRV-1],IRM1[INX-1],N,A,RM[IAL-1],IRM1);
KRV := IRV + N - 1;
ITM := ITM + 1;
{   OPMPOBAHE BYKO HEHO }
{   KOMHA HAPABEH CYCKA }
MNR53(ITM,RM[IRV-1],N,DEL,RM[IRX-1]);
P := 2;
if ( ITM =  N ) 
 then goto _130;
_110:
for J:=1 to N do
 begin
  IPJ1 := IP + J - 1;
  IRVJ1 := IRV + J - 1;
  RM[IPJ1-1] := (X[J-1] - RM[IRVJ1-1])*IRM[J-1];
_120:
 end;
goto _150;
_130:
for J:=1 to N do
 begin
  IPJ1 := IP + J - 1;
  IRXJ1 := IRX + J - 1;
  RM[IPJ1-1] := (X[J-1] - RM[IRXJ1-1])*IRM[J-1];
_140:
 end;
ITM := 0;
MNR1S(G,RM[IP-1],N,S);
if ( S <=  0.0 ) 
 then goto _110;
_150:
{  OOTOBKA K OHOMEPHO MHMA }
MNR1N(RM[IP-1],N,HL);
RM[IUP-1] := 2;
MNR1S(XE,RM[IP-1],N,S);
{   POBEPKA KPTEPEB OCTAHOBA }
if ( HL*HL <  Abs(S) ) 
 then goto _160;
RM[IUP+0] := Abs(S)*Z1/(Z*HL);
RM[IUP+1] := 2;
RM[IUP+2] := 5;
RM[IUP+3] := 18;
RM[IUP+4] := 12;
FT := F;
H := 0.1;
MNK3R(N,IRM,RM[IP-1],1.0,H,X,F,FE1,G,GE,FUNC,GRAD,
     RM[IUP-1],IRM[IIP-1],RM[IR2-1]);
{  OPAOTKA PEYTATOB OHOMEPHO MHMA }
RM[1] := RM[1] + IRM[IIP-1];
RM[2] := RM[2] + IRM[IIP+0];
RM[0] := RM[0] + 1;
{  POBEPKA KPTEPEB OKOHAH CETA }
UTMN05(T1);
if ( RM[0] >  MAXIT ) 
 then IERR := IERR*10 + 4;
if ( FT - F <  FE1*1.1 ) 
 then FE1 := FE1/UP[2];
if ( FE1*1.01 <  FE ) 
 then IERR := IERR*10 + 2;
if ( H <  RM[IUP+0]*1.1 ) 
 then Z1 := Z1/UP[1];
if ( Z1*1.01 <  Z ) 
 then IERR := IERR*10 + 1;
if ( T1 - T0 >  MT ) 
 then IERR := IERR*10 + 5;
if ( IERR <>  0 ) 
 then goto _170;
if ( IRM[IIP+1] =  1 ) 
 then goto _90;
goto _80;
_160:
IERR := 1;
_170:
end;

end.
