{    var   : }
{ M, DA, N, KV, EPS }
Unit ML07R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLU01_p, MLU07_p, MLU17_p, MLU18_p, MLU28_p, MLU29_p, MLU30_p,
MLU32_p, MLU33_p, MLU34_p, MLU43_p;

procedure ML07R(var A :Array of Real; var DA :Integer;
                var U :Array of Real; var M :Integer;
                var T :Array of Real; var N :Integer;
                var SUM :Array of Real; var NS :Array of Integer;
                var NT :Array of Integer; var NSUM :Array of Integer;
                var NE :Integer; var X :Array of Real;
                var NX :Array of Integer; var P :Integer;
                var EPS :Real; var XK :Array of Real;
                var ALFA :Array of Real; var KV :Integer;
                var NALFA :Array of Integer);

implementation

procedure ML07R(var A :Array of Real; var DA :Integer;
                var U :Array of Real; var M :Integer;
                var T :Array of Real; var N :Integer;
                var SUM :Array of Real; var NS :Array of Integer;
                var NT :Array of Integer; var NSUM :Array of Integer;
                var NE :Integer; var X :Array of Real;
                var NX :Array of Integer; var P :Integer;
                var EPS :Real; var XK :Array of Real;
                var ALFA :Array of Real; var KV :Integer;
                var NALFA :Array of Integer);
var
I,I1,K,L,M1,NA,NI :Integer;
MIN,TETA :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170;
begin
if ( P =  0 ) 
 then goto _20;
if ( P =  2 ) 
 then goto _40;
for I:=1 to N do
 begin
  T[I-1] := -T[I-1];
_10:
 end;
_20:
MLU01(U,M);
for I:=1 to M do
 begin
  K := N + I;
  NX[I-1] := K;
_30:
 end;
NI := 0;
NE := 1;
goto _50;
_40:
NI := 0;
{  EPECET (M-1)-O CTPOK MATP U }
{   X(M-1)  HOBO EEBO YHK }
MLU43(X,NX,M,U,T);
goto _130;
_50:
MLU28(MIN,U,M,A,DA,NS,N,NT,NSUM,SUM,T,K,ALFA,KV,NALFA);
goto _80;
_60:
MLU30(MIN,U,M,A,DA,N,NS,NT,NSUM,SUM,T,K,ALFA,KV,NALFA);
goto _80;
_70:
MLU29(MIN,U,M,A,DA,N,NS,NT,NSUM,SUM,T,K,ALFA,KV,NALFA,EPS);
_80:
if ( MIN <  -EPS ) 
 then goto _110;
case NE of
 1: goto _90;
 2: goto _140;
 3: goto _140;
end;
_90:
NE := 2;
M1 := M - 2;
for I:=1 to M1 do
 begin
  I1 := NX[I-1];
  if ( I1 >  N ) 
   then NE := 3;
_100:
 end;
if ( NE =  3 ) and (  X[M-1] <  -EPS ) 
 then goto _150;
case NE of
 1: goto _50;
 2: goto _60;
 3: goto _70;
end;
_110:
MLU17(U,M,A,DA,NS,T,N,NT,SUM,K,XK);
MLU32(X,M,XK,K,L,TETA,NX,EPS,ALFA,KV,NA,NALFA);
if ( TETA =  10.E+10 ) 
 then goto _160;
MLU33(TETA,L,K,XK,M,ALFA,KV,NA,NALFA,NX);
_120:
MLU18(X,XK,M,K,L,TETA,ALFA,KV,NA);
if ( L =  0 ) 
 then goto _130;
MLU07(U,M,XK,L);
MLU34(NX,M,K,L,SUM,N,NSUM);
_130:
NI := NI + 1;
case NE of
 1: goto _50;
 2: goto _60;
 3: goto _70;
end;
_140:
if ( P <>  1 ) 
 then X[M-2] := -X[M-2];
P := 1;
goto _170;
_150:
P := 2;
goto _170;
_160:
P := 3;
_170:
end;

end.
