Unit MNR53_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNR53(ITM :Integer; var X :Array of Real; N :Integer;
                DEL :Real; var RM :Array of Real);

implementation

procedure MNR53(ITM :Integer; var X :Array of Real; N :Integer;
                DEL :Real; var RM :Array of Real);
var
J :Integer;
DELI :Real;
label
_10,_20,_30;
begin
if ( ITM <>  1 ) 
 then goto _20;
for J:=1 to N do
 begin
  RM[J-1] := 0.0;
_10:
 end;
_20:
DELI := ITM*DEL;
for J:=1 to N do
 begin
  RM[J-1] := RM[J-1] + DELI*X[J-1];
_30:
 end;
end;

end.
